Index: mariadb-10.11.11/mysys/my_largepage.c
===================================================================
--- mariadb-10.11.11.orig/mysys/my_largepage.c
+++ mariadb-10.11.11/mysys/my_largepage.c
@@ -35,17 +35,11 @@ extern int memcntl(caddr_t, size_t, int,
 #endif /* __sun__ ... */
 #endif /* HAVE_SOLARIS_LARGE_PAGES */
 
-#if defined(_WIN32)
-static size_t my_large_page_size;
-#define HAVE_LARGE_PAGES
-#elif defined(HAVE_MMAP)
-#define HAVE_LARGE_PAGES
-#endif
 
-#ifdef HAVE_LARGE_PAGES
-static my_bool my_use_large_pages= 0;
-#else
-#define my_use_large_pages 0
+my_bool my_use_large_pages;
+
+#ifdef _WIN32
+static size_t my_large_page_size;
 #endif
 
 #if defined(HAVE_GETPAGESIZES) || defined(__linux__)
@@ -172,7 +166,7 @@ static void my_get_large_page_sizes(size
   @retval  a large page size that is valid on this system or 0 if no large page
            size possible.
 */
-#if defined(HAVE_MMAP) && !defined(_WIN32)
+#ifndef _WIN32
 static size_t my_next_large_page_size(size_t sz, int *start)
 {
   DBUG_ENTER("my_next_large_page_size");
@@ -188,11 +182,12 @@ static size_t my_next_large_page_size(si
   }
   DBUG_RETURN(0);
 }
-#endif /* defined(MMAP) || !defined(_WIN32) */
+#endif
 
 
-int my_init_large_pages(my_bool super_large_pages)
+int my_init_large_pages(void)
 {
+  my_use_large_pages= 1;
 #ifdef _WIN32
   if (!my_obtain_privilege(SE_LOCK_MEMORY_NAME))
   {
@@ -200,19 +195,15 @@ int my_init_large_pages(my_bool super_la
                     "Lock Pages in memory access rights required for use with"
                     " large-pages, see https://mariadb.com/kb/en/library/"
                     "mariadb-memory-allocation/#huge-pages", MYF(MY_WME));
+    my_use_large_pages= 0;
   }
   my_large_page_size= GetLargePageMinimum();
 #endif
 
-  my_use_large_pages= 1;
   my_get_large_page_sizes(my_large_page_sizes);
 
-#ifndef HAVE_LARGE_PAGES
-  my_printf_error(EE_OUTOFMEMORY, "No large page support on this platform",
-                  MYF(MY_WME));
-#endif
-
 #ifdef HAVE_SOLARIS_LARGE_PAGES
+  extern my_bool opt_super_large_pages;
   /*
     tell the kernel that we want to use 4/256MB page for heap storage
     and also for the stack. We use 4 MByte as default and if the
@@ -222,9 +213,15 @@ int my_init_large_pages(my_bool super_la
     measured in a number of GBytes.
     We use as big pages as possible which isn't bigger than the above
     desired page sizes.
+
+    Note: This refers to some implementations of the SPARC ISA,
+    where the supported page sizes are
+    8KiB, 64KiB, 512KiB, 4MiB, 32MiB, 256MiB, 2GiB, and 16GiB.
+    On implementations of the AMD64 ISA, the available page sizes
+    should be 4KiB, 2MiB, and 1GiB.
   */
   int nelem= 0;
-  size_t max_desired_page_size= (super_large_pages ? 256 : 4) * 1024 * 1024;
+  size_t max_desired_page_size= opt_super_large_pages ? 256 << 20 : 4 << 20;
   size_t max_page_size= my_next_large_page_size(max_desired_page_size, &nelem);
 
   if (max_page_size > 0)
@@ -426,6 +423,118 @@ uchar *my_large_malloc(size_t *size, myf
   DBUG_RETURN(ptr);
 }
 
+#ifdef _WIN32
+/**
+  Special large pages allocator, with possibility to commit to allocating
+  more memory later.
+  Every implementation returns a zero filled buffer here.
+*/
+char *my_large_virtual_alloc(size_t *size)
+{
+  char *ptr;
+  DBUG_ENTER("my_large_virtual_alloc");
+
+  if (my_use_large_pages)
+  {
+    size_t s= *size;
+    s= MY_ALIGN(s, (size_t) my_large_page_size);
+    ptr= VirtualAlloc(NULL, s, MEM_COMMIT | MEM_RESERVE | MEM_LARGE_PAGES,
+                      PAGE_READWRITE);
+    if (ptr)
+    {
+      *size= s;
+      DBUG_RETURN(ptr);
+    }
+  }
+
+  DBUG_RETURN(VirtualAlloc(NULL, *size, MEM_RESERVE, PAGE_READWRITE));
+}
+#elif defined HAVE_MMAP
+/**
+  Special large pages allocator, with possibility to commit to allocating
+  more memory later.
+  Every implementation returns a zero filled buffer here.
+*/
+char *my_large_mmap(size_t *size, int prot)
+{
+  char *ptr;
+  DBUG_ENTER("my_large_virtual_alloc");
+
+  if (my_use_large_pages)
+  {
+    size_t large_page_size;
+    int page_i= 0;
+    prot= PROT_READ | PROT_WRITE;
+
+    while ((large_page_size= my_next_large_page_size(*size, &page_i)) != 0)
+    {
+      int mapflag= MAP_PRIVATE |
+# ifdef MAP_POPULATE
+        MAP_POPULATE |
+# endif
+# if defined MAP_HUGETLB /* linux 2.6.32 */
+        MAP_HUGETLB |
+#  if defined MAP_HUGE_SHIFT /* Linux-3.8+ */
+        my_bit_log2_size_t(large_page_size) << MAP_HUGE_SHIFT |
+#  else
+#   warning "No explicit large page (HUGETLB pages) support in Linux < 3.8"
+#  endif
+# elif defined MAP_ALIGNED
+        MAP_ALIGNED(my_bit_log2_size_t(large_page_size)) |
+#  if defined MAP_ALIGNED_SUPER
+        MAP_ALIGNED_SUPER |
+#  endif
+# endif
+        OS_MAP_ANON;
+
+      size_t aligned_size= MY_ALIGN(*size, (size_t) large_page_size);
+      ptr= mmap(NULL, aligned_size, prot, mapflag, -1, 0);
+      if (ptr == (void*) -1)
+      {
+        ptr= NULL;
+        /* try next smaller memory size */
+        if (errno == ENOMEM)
+          continue;
+
+        /* other errors are more serious */
+        break;
+      }
+      else /* success */
+      {
+        /*
+          we do need to record the adjustment so that munmap gets called with
+          the right size. This is only the case for HUGETLB pages.
+        */
+        *size= aligned_size;
+        DBUG_RETURN(ptr);
+      }
+    }
+  }
+
+  ptr= mmap(NULL, *size, prot,
+# ifdef MAP_NORESERVE
+            MAP_NORESERVE |
+# endif
+            MAP_PRIVATE | OS_MAP_ANON, -1, 0);
+  if (ptr == MAP_FAILED)
+  {
+    my_error(EE_OUTOFMEMORY, MYF(ME_BELL + ME_ERROR_LOG), size);
+    ptr= NULL;
+  }
+
+  DBUG_RETURN(ptr);
+}
+
+/**
+  Special large pages allocator, with possibility to commit to allocating
+  more memory later.
+  Every implementation returns a zero filled buffer here.
+*/
+char *my_large_virtual_alloc(size_t *size)
+{
+  return my_large_mmap(size, PROT_READ | PROT_WRITE);
+}
+#endif
 
 /**
   General large pages deallocator.
@@ -482,7 +591,7 @@ void my_large_free(void *ptr, size_t siz
 #endif /* memory_sanitizer */
 #else
   my_free_lock(ptr);
-#endif /* HAVE_MMMAP */
+#endif /* HAVE_MMAP */
 
   DBUG_VOID_RETURN;
 }
Index: mariadb-10.11.11/mysys/my_virtual_mem.c
===================================================================
--- /dev/null
+++ mariadb-10.11.11/mysys/my_virtual_mem.c
@@ -0,0 +1,207 @@
+/* Copyright (c) 2025, MariaDB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1335  USA */
+
+#include <my_global.h>
+#include <my_sys.h>
+#include <mysys_err.h>
+#include <my_virtual_mem.h>
+#ifdef _AIX
+# include <sys/shm.h>
+#endif
+
+/*
+  Functionality for handling virtual memory
+
+  - reserve range,
+  - commit memory (within reserved range)
+  - decommit previously commited memory
+  - release range
+
+  Not every OS has a "reserve" functionality, i.e it is not always
+  possible to reserve memory larger than swap or RAM for example.
+
+  We try to respect use_large_pages setting, on Windows and Linux
+*/
+#ifndef _WIN32
+char *my_large_mmap(size_t *size, int prot);
+#endif
+
+char *my_virtual_mem_reserve(size_t *size)
+{
+#ifdef _WIN32
+  DWORD flags= my_use_large_pages
+    ? MEM_LARGE_PAGES | MEM_RESERVE | MEM_COMMIT
+    : MEM_RESERVE;
+  char *ptr= VirtualAlloc(NULL, *size, flags, PAGE_READWRITE);
+  if (!ptr && (flags & MEM_LARGE_PAGES))
+  {
+    /* Try without large pages */
+    ptr= VirtualAlloc(NULL, *size, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
+    if (!ptr)
+      my_error(EE_OUTOFMEMORY, MYF(ME_BELL + ME_ERROR_LOG), *size);
+  }
+  return ptr;
+#else
+  return my_large_mmap(size, PROT_NONE);
+#endif
+}
+
+#if defined _WIN32 && !defined DBUG_OFF
+static my_bool is_memory_committed(char *ptr, size_t size)
+{
+  MEMORY_BASIC_INFORMATION mbi;
+  if (VirtualQuery(ptr, &mbi, sizeof mbi) == 0)
+    DBUG_ASSERT(0);
+  return !!(mbi.State & MEM_COMMIT);
+}
+#endif
+
+char *my_virtual_mem_commit(char *ptr, size_t size)
+{
+  DBUG_ASSERT(ptr);
+#ifdef _WIN32
+  if (my_use_large_pages)
+  {
+    DBUG_ASSERT(is_memory_committed(ptr, size));
+  }
+  else
+  {
+    void *p= VirtualAlloc(ptr, size, MEM_COMMIT, PAGE_READWRITE);
+    DBUG_ASSERT(p == ptr);
+    if (!p)
+    {
+      my_error(EE_OUTOFMEMORY, MYF(ME_BELL + ME_ERROR_LOG), size);
+      return NULL;
+    }
+  }
+#else
+  if (my_use_large_pages)
+    /* my_large_mmap() already created a read/write mapping. */;
+  else
+  {
+# ifdef _AIX
+    /*
+      MAP_FIXED does not not work on IBM AIX in the way does works elsewhere.
+      Apparently, it is not possible to mmap(2) a range that is already in use,
+      at least not by default.
+
+      mprotect(2) is the fallback, it can't communicate out-of-memory
+      conditions, but it looks like overcommitting is not possible on
+      AIX anyway.
+    */
+    if (mprotect(ptr, size, PROT_READ | PROT_WRITE))
+    {
+      my_error(EE_OUTOFMEMORY, MYF(ME_BELL + ME_ERROR_LOG), size);
+      return NULL;
+    }
+# else
+    void *p= 0;
+    const int flags=
+#  ifdef MAP_POPULATE
+      MAP_POPULATE |
+#  endif
+      MAP_PRIVATE | MAP_ANONYMOUS | MAP_FIXED;
+    p= mmap(ptr, size, PROT_READ | PROT_WRITE, flags, -1, 0);
+    if (p == MAP_FAILED)
+    {
+      my_error(EE_OUTOFMEMORY, MYF(ME_BELL + ME_ERROR_LOG), size);
+      return NULL;
+    }
+    DBUG_ASSERT(p == ptr);
+#  if defined MADV_FREE_REUSABLE && defined MADV_FREE_REUSE /* Apple macOS */
+    madvise(ptr, size, MADV_FREE_REUSE); /* cancel MADV_FREE_REUSABLE */
+#  endif
+# endif
+  }
+#endif
+  update_malloc_size(size, 0);
+  return ptr;
+}
+
+void my_virtual_mem_decommit(char *ptr, size_t size)
+{
+#ifdef _WIN32
+  DBUG_ASSERT(is_memory_committed(ptr, size));
+# ifndef HAVE_UNACCESSIBLE_AFTER_MEM_DECOMMIT
+#  error "VirtualFree(MEM_DECOMMIT) will not allow subsequent reads!"
+# endif
+  if (!my_use_large_pages)
+  {
+    if (!VirtualFree(ptr, size, MEM_DECOMMIT))
+    {
+      my_error(EE_BADMEMORYRELEASE, MYF(ME_ERROR_LOG_ONLY), ptr, size,
+               GetLastError());
+      DBUG_ASSERT(0);
+    }
+  }
+#else
+  const int prot=
+# ifndef HAVE_UNACCESSIBLE_AFTER_MEM_DECOMMIT
+    /*
+      In InnoDB, buf_pool_t::page_guess() may deference pointers to
+      this, assuming that either the original contents or zeroed
+      contents is available.
+    */
+    PROT_READ
+# else
+    /* We will explicitly mark the memory unaccessible. */
+    PROT_NONE
+# endif
+    ;
+# ifdef _AIX
+  disclaim(ptr, size, DISCLAIM_ZEROMEM);
+# elif defined __linux__ || defined __osf__
+  madvise(ptr, size, MADV_DONTNEED); /* OSF/1, Linux mimicing AIX disclaim() */
+# elif defined MADV_FREE_REUSABLE && defined MADV_FREE_REUSE
+  /* Mac OS X 10.9; undocumented in Apple macOS */
+  madvise(ptr, size, MADV_FREE_REUSABLE); /* macOS mimicing AIX disclaim() */
+# elif defined MADV_PURGE /* Illumos */
+  madvise(ptr, size, MADV_PURGE); /* Illumos mimicing AIX disclaim() */
+# elif defined MADV_FREE
+  /* FreeBSD, NetBSD, OpenBSD, Dragonfly BSD, OpenSolaris, Apple macOS */
+  madvise(ptr, size, MADV_FREE); /* allow lazy zeroing out */
+# elif defined MADV_DONTNEED
+#  warning "It is unclear if madvise(MADV_DONTNEED) works as intended"
+  madvise(ptr, size, MADV_DONTNEED);
+# else
+#  warning "Do not know how to decommit memory"
+# endif
+  if (mprotect(ptr, size, prot))
+  {
+    my_error(EE_BADMEMORYRELEASE, MYF(ME_ERROR_LOG_ONLY), ptr, size, errno);
+    DBUG_ASSERT(0);
+  }
+#endif
+  update_malloc_size(-(longlong) size, 0);
+}
+
+void my_virtual_mem_release(char *ptr, size_t size)
+{
+#ifdef _WIN32
+  DBUG_ASSERT(my_use_large_pages || !is_memory_committed(ptr, size));
+  if (!VirtualFree(ptr, 0, MEM_RELEASE))
+  {
+    my_error(EE_BADMEMORYRELEASE, MYF(ME_ERROR_LOG_ONLY), ptr, size,
+             GetLastError());
+    DBUG_ASSERT(0);
+  }
+#else
+  if (munmap(ptr, size))
+  {
+    my_error(EE_BADMEMORYRELEASE, MYF(ME_ERROR_LOG_ONLY), ptr, size, errno);
+    DBUG_ASSERT(0);
+  }
+#endif
+}
Index: mariadb-10.11.11/sql/mysql_install_db.cc
===================================================================
--- mariadb-10.11.11.orig/sql/mysql_install_db.cc
+++ mariadb-10.11.11/sql/mysql_install_db.cc
@@ -336,7 +336,7 @@ static char *init_bootstrap_command_line
     " --bootstrap"
     " --datadir=."
     " --tmpdir=."
-    " --loose-innodb-buffer-pool-size=20M"
+    " --loose-innodb-buffer-pool-size=21M"
     "\""
     , mysqld_path, opt_verbose_bootstrap ? "--console" : "");
   return cmdline;
Index: mariadb-10.11.11/sql/mysqld.cc
===================================================================
--- mariadb-10.11.11.orig/sql/mysqld.cc
+++ mariadb-10.11.11/sql/mysqld.cc
@@ -420,7 +420,9 @@ my_bool opt_require_secure_transport= 0;
 char* opt_secure_file_priv;
 my_bool lower_case_file_system= 0;
 my_bool opt_large_pages= 0;
+#ifdef HAVE_SOLARIS_LARGE_PAGES
 my_bool opt_super_large_pages= 0;
+#endif
 my_bool opt_myisam_use_mmap= 0;
 uint   opt_large_page_size= 0;
 #if defined(ENABLED_DEBUG_SYNC)
@@ -4118,7 +4120,7 @@ static int init_common_variables()
   if (opt_large_pages)
   {
     DBUG_PRINT("info", ("Large page set"));
-    if (my_init_large_pages(opt_super_large_pages))
+    if (my_init_large_pages())
     {
       return 1;
     }
@@ -7872,7 +7874,9 @@ static int mysql_init_variables(void)
   bzero((char*) &global_status_var, offsetof(STATUS_VAR,
                                              last_cleared_system_status_var));
   opt_large_pages= 0;
+#ifdef HAVE_SOLARIS_LARGE_PAGES
   opt_super_large_pages= 0;
+#endif
 #if defined(ENABLED_DEBUG_SYNC)
   opt_debug_sync_timeout= 0;
 #endif /* defined(ENABLED_DEBUG_SYNC) */
Index: mariadb-10.11.11/storage/innobase/btr/btr0sea.cc
===================================================================
--- mariadb-10.11.11.orig/storage/innobase/btr/btr0sea.cc
+++ mariadb-10.11.11/storage/innobase/btr/btr0sea.cc
@@ -195,7 +195,7 @@ static void btr_search_disable_ref_count
 }
 
 /** Lazily free detached metadata when removing the last reference. */
-ATTRIBUTE_COLD static void btr_search_lazy_free(dict_index_t *index)
+ATTRIBUTE_COLD void btr_search_lazy_free(dict_index_t *index)
 {
   ut_ad(index->freed());
   dict_table_t *table= index->table;
@@ -219,8 +219,7 @@ ATTRIBUTE_COLD static void btr_search_la
   table->autoinc_mutex.wr_unlock();
 }
 
-/** Disable the adaptive hash search system and empty the index. */
-void btr_search_disable()
+ATTRIBUTE_COLD bool btr_search_disable()
 {
 	dict_table_t*	table;
 
@@ -231,7 +230,7 @@ void btr_search_disable()
 	if (!btr_search_enabled) {
 		dict_sys.unfreeze();
 		btr_search_x_unlock_all();
-		return;
+		return false;
 	}
 
 	btr_search_enabled = false;
@@ -259,23 +258,25 @@ void btr_search_disable()
 	btr_search_sys.clear();
 
 	btr_search_x_unlock_all();
+
+	return true;
 }
 
 /** Enable the adaptive hash search system.
 @param resize whether buf_pool_t::resize() is the caller */
-void btr_search_enable(bool resize)
+ATTRIBUTE_COLD void btr_search_enable(bool resize)
 {
 	if (!resize) {
 		mysql_mutex_lock(&buf_pool.mutex);
-		bool changed = srv_buf_pool_old_size != srv_buf_pool_size;
+		const auto is_shrinking = buf_pool.is_shrinking();
 		mysql_mutex_unlock(&buf_pool.mutex);
-		if (changed) {
+		if (is_shrinking) {
 			return;
 		}
 	}
 
 	btr_search_x_lock_all();
-	ulint hash_size = buf_pool_get_curr_size() / sizeof(void *) / 64;
+	ulint hash_size = buf_pool.curr_size() / sizeof(void *) / 64;
 
 	if (btr_search_sys.parts[0].heap) {
 		ut_ad(btr_search_enabled);
@@ -939,88 +940,6 @@ btr_search_failure(btr_search_t* info, b
 	info->last_hash_succ = FALSE;
 }
 
-/** Clear the adaptive hash index on all pages in the buffer pool. */
-inline void buf_pool_t::clear_hash_index() noexcept
-{
-  ut_ad(!resizing);
-  ut_ad(!btr_search_enabled);
-
-  std::set<dict_index_t*> garbage;
-
-  for (chunk_t *chunk= chunks + n_chunks; chunk-- != chunks; )
-  {
-    for (buf_block_t *block= chunk->blocks, * const end= block + chunk->size;
-         block != end; block++)
-    {
-      dict_index_t *index= block->index;
-      assert_block_ahi_valid(block);
-
-      /* We can clear block->index and block->n_pointers when
-      holding all AHI latches exclusively; see the comments in buf0buf.h */
-
-      if (!index)
-      {
-# if defined UNIV_AHI_DEBUG || defined UNIV_DEBUG
-        ut_a(!block->n_pointers);
-# endif /* UNIV_AHI_DEBUG || UNIV_DEBUG */
-        continue;
-      }
-
-      ut_d(const auto s= block->page.state());
-      /* Another thread may have set the state to
-      REMOVE_HASH in buf_LRU_block_remove_hashed().
-
-      The state change in buf_pool_t::realloc() is not observable
-      here, because in that case we would have !block->index.
-
-      In the end, the entire adaptive hash index will be removed. */
-      ut_ad(s >= buf_page_t::UNFIXED || s == buf_page_t::REMOVE_HASH);
-# if defined UNIV_AHI_DEBUG || defined UNIV_DEBUG
-      block->n_pointers= 0;
-# endif /* UNIV_AHI_DEBUG || UNIV_DEBUG */
-      if (index->freed())
-        garbage.insert(index);
-      block->index= nullptr;
-    }
-  }
-
-  for (dict_index_t *index : garbage)
-    btr_search_lazy_free(index);
-}
-
-/** Get a buffer block from an adaptive hash index pointer.
-This function does not return if the block is not identified.
-@param ptr  pointer to within a page frame
-@return pointer to block, never NULL */
-inline buf_block_t* buf_pool_t::block_from_ahi(const byte *ptr) const noexcept
-{
-  chunk_t::map *chunk_map = chunk_t::map_ref;
-  ut_ad(chunk_t::map_ref == chunk_t::map_reg);
-  ut_ad(!resizing);
-
-  chunk_t::map::const_iterator it= chunk_map->upper_bound(ptr);
-  ut_a(it != chunk_map->begin());
-
-  chunk_t *chunk= it == chunk_map->end()
-    ? chunk_map->rbegin()->second
-    : (--it)->second;
-
-  const size_t offs= size_t(ptr - chunk->blocks->page.frame) >>
-    srv_page_size_shift;
-  ut_a(offs < chunk->size);
-
-  buf_block_t *block= &chunk->blocks[offs];
-  /* buf_pool_t::chunk_t::init() invokes buf_block_init() so that
-  block[n].frame == block->page.frame + n * srv_page_size.  Check it. */
-  ut_ad(block->page.frame == page_align(ptr));
-  /* Read the state of the block without holding hash_lock.
-  A state transition to REMOVE_HASH is possible during
-  this execution. */
-  ut_ad(block->page.state() >= buf_page_t::REMOVE_HASH);
-
-  return block;
-}
-
 /** Tries to guess the right search position based on the hash search info
 of the index. Note that if mode is PAGE_CUR_LE, which is used in inserts,
 and the function returns TRUE, then cursor->up_match and cursor->low_match
@@ -1103,7 +1022,8 @@ fail:
 		return false;
 	}
 
-	buf_block_t* block = buf_pool.block_from_ahi(rec);
+	buf_block_t* block = buf_pool.block_from(rec);
+	ut_ad(block->page.frame == page_align(rec));
 
 	buf_pool_t::hash_chain& chain = buf_pool.page_hash.cell_get(
 		block->page.id().fold());
@@ -2196,7 +2116,7 @@ func_exit:
 
 		for (; node != NULL; node = node->next) {
 			const buf_block_t*	block
-				= buf_pool.block_from_ahi((byte*) node->data);
+				= buf_pool.block_from(node->data);
 			index_id_t		page_index_id;
 
 			if (UNIV_LIKELY(block->page.in_file())) {
